program ObjEdit;

uses Graph,Crt;

const MaxWFSize = 26;

type WireFrame = Object
	FName:String;
	Cursor:Integer;
	Lines:Array[1..MAXWFSize+1] of Byte;
	constructor Init(s:String);
	procedure   Paint;
	procedure	Load;
	procedure	Save;
end;

const Dirs:array[0..7] of String
		= ( 'N','NE','E','SE','S','SW','W','NW' );

procedure ConvertCoordinate(x,y:Integer;var x1,y1:Integer);
begin
	x1 := x*11+32;y1 := (31-y)*8+32;
end;

constructor WireFrame.Init(s:String);
var i:Integer;
begin
	for i := 1 to MAXWFSize+1 do Lines[i] := $01;
	Cursor := 1;
	FName := s;
end;

procedure WireFrame.Save;
var f:File of Byte;
	ft:Text;
	i:Integer;
begin
	Assign(f,Concat(FName,'.wfr'));
	Rewrite(f);
	for i := 1 to MAXWFSize+1 do Write(f,Lines[i]);
	Close(f);
	Assign(ft,Concat(FName,'.inc'));
	Rewrite(ft);
	Write(ft,'    .db ');
	for i := 1 to MAXWFSize+1 do
		if Lines[i] >= 16 then Write(ft,Lines[i],',');
	WriteLn(ft,0);
	Close(ft);
end;

procedure WireFrame.Load;
var f:File of Byte;
	i:Integer;
begin
	Assign(f,Concat(FName,'.wfr'));
	{$I-}
	Reset(f);
	{$I+}
	if IOResult = 0 then
		begin
			for i := 1 to MAXWFSize+1 do Read(f,Lines[i]);
			Close(f);
		end;
end;

const	xOrigin = 16;
		yOrigin = 16*0;

procedure WireFrame.Paint;
var i,n,x,y,x1,y1,x2,y2:Integer;
	b:Byte;
	s,s1:String;
begin
	ClearDevice;
	SetColor(White);Bar(0,0,640,10);
	s := 'WireFrame Object Editor - ('+FName+')';
	SetColor(Black);OutTextXY(16,2,s);
	for i := 1 to MAXWFSize do
		begin
			s := Chr(i+96)+') ';b := Lines[i];
			if b mod 2 = 0 then
				s := Concat(s,'Plot ')
			else
				s := Concat(s,'Draw ');

			Str(b div 16,s1);
			s := Concat(s,Dirs[b div 2 mod 8],',',s1);
			{ if b < 16 then s := Chr(i+96)+') ...'; }
			SetColor(Green);if i = Cursor then SetColor(Yellow);
			OutTextXY(500,i*10+10,s);
		end;
	ConvertCoordinate(0,0,x1,y1);ConvertCoordinate(32,32,x2,y2);
	SetColor(White);Rectangle(x1,y1,x2,y2);
	ConvertCoordinate(xOrigin,yOrigin,x1,y1);Circle(x1,y1,4);
	x := xOrigin;y := yOrigin;
	for i := 1 to MaxWFSize do
		begin
			if Lines[i] > 15 then
				begin
					ConvertCoordinate(x,y,x1,y1);
					b := Lines[i];
					n := b div 16;
					b := (b div 2) mod 8;

					if b in [7,0,1] then y := y + n;
					if b in [1,2,3] then x := x + n;
					if b in [3,4,5] then y := y - n;
					if b in [5,6,7] then x := x - n;

					ConvertCoordinate(x,y,x2,y2);
					SetColor(Green);
					if i = Cursor then SetColor(Yellow);
					if Lines[i] mod 2 <> 0 then Line(x1,y1,x2,y2);
				end;
		end;
	SetColor(Cyan);Circle(x2,y2,4);
end;

procedure Adjust(var r:Byte;d:Integer);
var s:Integer;
begin
	s := (r div 16 + d) and $0F;
	r := s * 16 + (r mod 16);
end;

var w:WireFrame;
	Key,GraphDriver,GraphMode:Integer;
	s:String;

begin
	if ParamCount <> 1 then Halt(0);
	GraphDriver := VGA;GraphMode := VGAMed;
	InitGraph(GraphDriver,GraphMode,'.');
	SetGraphMode(GraphMode);

	w.Init(ParamStr(1));
	w.Load;

	repeat
		w.Paint;
		{ str(Key,s);OutTextXY(8,8,s); }
		Key := Ord(ReadKey);
		if Key = 0 then Key := -Ord(ReadKey);
		if Key in [97..122] then Key := Key-32;

		case Key of
			-72:	Dec(w.Cursor);
			-80:	Inc(w.Cursor);
			13:		w.Lines[w.Cursor] := w.Lines[w.Cursor] xor $01;
			49:		w.Lines[w.Cursor] := w.Lines[w.Cursor] and $F1 or 5*2;
			50:		w.Lines[w.Cursor] := w.Lines[w.Cursor] and $F1 or 4*2;
			51:		w.Lines[w.Cursor] := w.Lines[w.Cursor] and $F1 or 3*2;
			52:		w.Lines[w.Cursor] := w.Lines[w.Cursor] and $F1 or 6*2;
			54:		w.Lines[w.Cursor] := w.Lines[w.Cursor] and $F1 or 2*2;
			55:		w.Lines[w.Cursor] := w.Lines[w.Cursor] and $F1 or 7*2;
			56:		w.Lines[w.Cursor] := w.Lines[w.Cursor] and $F1 or 0*2;
			57:		w.Lines[w.Cursor] := w.Lines[w.Cursor] and $F1 or 1*2;
			-75:	Adjust(w.Lines[w.Cursor],-1);
			-77:	Adjust(w.Lines[w.Cursor],1);
		end;

		if w.Cursor = 0 then w.Cursor := MaxWFSize;
		if w.Cursor > MaxWFSize then w.Cursor := 1;
	until Key = Ord('Q');
	w.Save;
	CloseGraph;
end.
