
program ViewDemo;

uses Graph,ViewAng,Crt;

var OCount,ViewAngle:Integer;

const xs = 4;ys = 3;

procedure DrawFrame;
var r:Real;
begin
	ClearDevice;
	SetColor(White);
	Rectangle(320-32*xs,32,320+32*xs,32+64*ys);
	OCount := 0;
	r := ViewAngle / 256.0 * 2.0 * Pi;
	SetColor(White);
	Line(520,100,520+Round(cos(r)*20),100-Round(sin(r)*20));
	Circle(520,100,40);
	OutTextXY(0,0,'A Pascal Demo of the Game Engine');
end;

procedure PaintObject(x1,y1,xs,ys:Integer);
begin
	{Rectangle(x1,y1,x1+xs,y1+ys);}
	Rectangle(x1+xs div 3,y1+ys,x1+xs * 2 div 3,y1+ys div 2);
	Circle(x1+xs div 2,y1+ys div 3,ys div 2);
end;

procedure DrawObject(x,y,Col:Integer);
var s1,s2,s3:String;
	xc,yc,sz:Integer;
	Ang:Integer;
	Dist:Integer;
begin
	Inc(OCount);
	SetColor(Col);

	{ Calculate viewing angle from offset coordinates }
	Ang := (ViewAngle-ViewingAngle(x,y)) and $FF;
	if Ang > 127 then Ang := Ang - 256;

	{ Calculate distance (roughly) to the object }
	Dist := (abs(x)+abs(y));

	{ This is debug code, showing object information }
	Str(x,s1);Str(y,s2);Str(Ang,s3);
	OutTextXY(10,OCount * 10 + 24,s1+','+s2+' @'+s3);

	{ If close, and in viewpoint OR very close }
	if (Dist <= 48) and (Abs(Ang) <= 64) or (Dist < 2) then
		begin
        	{ Calculate vertical position }
			yc := 12 + Dist;
			{ Calculate horizontal position }
			xc := 0;
			if Dist >= 2 then xc := Ang * Dist div 32;

			{ If in the viewscreen area }
			if abs(xc) <= 32 then
				begin
					{ Calculate the object target size }
					if Dist = 0 then Dist := 1;
		            sz := 128 div Dist;
					if sz > 16 then sz := 16;

					{ And draw it }
					SetColor(Col);
					PaintObject(320+xc*xs-sz*xs div 2,32+(64-yc)*ys-sz*ys,sz*xs,sz*ys);
				end;
		end;

	xc := 520+x; yc := 100-y;
	Line(xc-2,yc-2,xc+2,yc+2);
	Line(xc+2,yc-2,xc-2,yc+2);
end;

var GraphDriver, GraphMode:Integer;
	c:Char;
	a,s1,s2:Real;

begin
	GraphDriver := EGA;GraphMode := EGAHi;
	InitGraph(GraphDriver,GraphMode,'.');
	SetGraphMode(GraphMode);
	ViewAngle := 64;
	s1 := 0;s2 := 0;
	repeat
		DrawFrame;
		DrawObject(0-trunc(s1),32-trunc(s2),Red);
		DrawObject(0-trunc(s1),120-trunc(s2),LightGray);
		DrawObject(24-trunc(s1),32-trunc(s2),Green);
		DrawObject(16-trunc(s1),32-trunc(s2),Cyan);
		DrawObject(8-trunc(s1),32-trunc(s2),Brown);
		DrawObject(-32-trunc(s1),32-trunc(s2),Blue);
		DrawObject(0-trunc(s1),8-trunc(s2),Yellow);
		DrawObject(-16-trunc(s1),16-trunc(s2),White);
		DrawObject(0-trunc(s1),-32-trunc(s2),Magenta);
		c := UpCase(ReadKey);
		a := ViewAngle / 256.0 * 2 * Pi;
		if c = 'Z' then ViewAngle := ViewAngle + 8;
		if c = 'X' then ViewAngle := ViewAngle - 8;
		if c = 'M' then
			begin
				s1 := s1 + Cos(a) * 2;
				s2 := s2 + Sin(a) * 2;
			end;
		ViewAngle := ViewAngle and $FF;
	until c = 'Q';
	CloseGraph;
end.
